//table.cpp
//CSE124C Section 4 Lab4 by Haibei Zhang

#include "table.h"

//constructor
table::table()
{
}


//Read the table from input.txt
void table::readTable()
{
	ifstream inputstream("input.txt");
	
	//Temporary integers to store a line of distances
	int d[6];
	//Temporary strings to store the first line (city names)
	Cstring c[6];

	//Read the first line of table (names of cities only), store in the city vector
	inputstream>>c[0]>>c[1]>>c[2]>>c[3]>>c[4]>>c[5];
	for(int i=0;i<6;i++)
		city.push_back(c[i]);

	//Read the rest lines, read one line each time, store integers into the distance vector
	for(int row=0;row<6;row++)
	{
		//read the whole line
		inputstream>>c[0]>>d[0]>>d[1]>>d[2]>>d[3]>>d[4]>>d[5];
		//only the lower left triangle is stored into the vector
		for(int j=0;j<row;j++)
			distance.push_back(d[j]);
	}

}

//Return the distance between 2 cities specified by its row and column
//0<=row<=5
//0<=col<=5
int table::getDistance(int row, int col)
{ 
	if(row==col)
		return 0;

	//if row>col, calculate the subscript of the vector and return that vector element
	if(row>col)
	{
		int sub=0;
		for(int i=0;i<row;i++)
			sub+=i;
		sub+=col;
		return distance[sub];
	}

	//if row<col, swap them
	else
		return getDistance(col, row);
	
}

//Print the table to output.txt
void table::printTable()
{
	ofstream outputstream("output.txt");
	outputstream<<"     ";
	
	//print the first line (names of cities)
	for(int i=0;i<6;i++)
		outputstream<<setw(5)<<setfill(' ')<<city[i];

	outputstream<<endl;

	//print rest lines
	for(int row=0;row<6;row++)
	{
		outputstream<<setw(5)<<setfill(' ')<<city[row];
		for(int j=0;j<6;j++)
			outputstream<<setw(5)<<setfill(' ')<<getDistance(row,j);
		outputstream<<endl;
	}
}